import sympy as sp

def sympify(expression):
    """expression est une chaîne de caractère qu'il faut transformer en objet sympy. On retourne une liste dont le deuxième élément est un booléen déterminant si la conversion a fonctionné
    """

    try:
        sp.sympify(expression)
        return [sp.sympify(expression),True]
    except:
        return ["Impossible de convertir l'expression",False]

def sympify_intervalle(string):
    """string est une expression de la forme a,b avec a,b des flottants ou oo ou -oo
    """
    intervalle = string.split(',')
    if len(intervalle) != 2:
        return ["La chaîne de caractère n'est pas au format [a,b]",False] 
    
    borne_inf = intervalle[0][0]
    borne_sup = intervalle[1][-1]
    caracteres_admissibles = ['[',']']
    if borne_inf not in caracteres_admissibles or borne_sup not in caracteres_admissibles:
        return ["La chaîne de caractère n'est pas au bon format [a,b]",False]

    a = intervalle[0][1:]
    b = intervalle[1][:-1]

    try:
        a = sp.sympify(a)
    except:
        return ["la borne inférieure n'est pas au bon format",False]
    try:
        b = sp.sympify(b)
    except:
        return ["la borne supérieure n'est pas au bon format",False]

    if borne_inf == '[' and borne_sup == ']':
        return [sp.Interval(a,b),True]
    elif borne_inf == ']' and borne_sup == '[':
        return [sp.Interval.open(a,b),True]
    elif borne_inf == ']' and borne_sup == ']':
        return [sp.Interval.Ropen(a,b),True]
    elif borne_inf == '[' and borne_sup == '[':
        return [sp.Interval.Lopen(a,b),True]

def sympify_intervalle2(string):
    if string == '':
        return ['',True]
    else:
        return sympify_intervalle(string)
